## PothosPlotters-0.4.1.tar.gz

=== CMakeLists.txt ===
########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.8.9)
project(PothosPlotters CXX)

if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    find_package(Pothos "0.6.0" CONFIG REQUIRED)
else()
    find_package(Pothos CONFIG REQUIRED) #in-tree build
endif()

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

#args to set the CMAKE_PREFIX_PATH environment variable
if (CMAKE_PREFIX_PATH)
    set(ENV{CMAKE_PREFIX_PATH} ${CMAKE_PREFIX_PATH})
endif (CMAKE_PREFIX_PATH)

########################################################################
# QT5 devel setup
########################################################################
#http://www.kdab.com/using-cmake-with-qt-5/
# Tell CMake to run moc when necessary:
set(CMAKE_AUTOMOC ON)
# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

unset(Qt5Enables)
foreach(comp Widgets Concurrent OpenGL Svg PrintSupport)
    find_package(Qt5${comp})
    set(Qt5Enables "${Qt5Enables};Qt5${comp}_FOUND")

    if(Qt5${comp}_FOUND)
        include_directories(${Qt5${comp}_INCLUDE_DIRS})
        add_definitions(${Qt5${comp}_DEFINITIONS})
        list(APPEND Qt5_LIBRARIES ${Qt5${comp}_LIBRARIES})
    else()
        MESSAGE(WARNING "Cant find Qt5${comp}")
    endif()
endforeach(comp)

########################################################################
# Spuce library
########################################################################
if(NOT SPUCE_IN_TREE)
    find_package(Spuce CONFIG)
endif(NOT SPUCE_IN_TREE)

if (Spuce_FOUND)
    message(STATUS "Spuce_VERSION: ${Spuce_VERSION}")
    message(STATUS "Spuce_INCLUDE_DIRS: ${Spuce_INCLUDE_DIRS}")
    message(STATUS "Spuce_LIBRARIES: ${Spuce_LIBRARIES}")
else (Spuce_FOUND)
    message(WARNING "Spuce filter designer library not found...")
endif (Spuce_FOUND)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_PLOTTERS "Enable Pothos Plotters component" ON "Pothos_FOUND;${Qt5Enables}" OFF)
add_feature_info(Plotters ENABLE_PLOTTERS "Graphical plotter widgets for the GUI")

########################################################################
# Qwt setup
########################################################################
find_package(Qwt)

add_definitions(-DQWT_DLL)

if (QWT_FOUND AND NOT QWT_VERSION_STRING)
    message(WARNING "Failed to extract QWT_VERSION_STRING from ${QWT_INCLUDE_DIRS} - using built-in Qwt")
    set(QWT_FOUND FALSE)
endif()

if (QWT_FOUND)
    message(STATUS "QWT_VERSION_STRING: ${QWT_VERSION_STRING}")
    if (QWT_VERSION_STRING LESS "6.1")
        set(QWT_FOUND FALSE)
        message(STATUS "Qwt older than v6.1 - using built-in Qwt")
    endif()
else (QWT_FOUND)
    message(STATUS "Qwt not found - using built-in Qwt")
endif (QWT_FOUND)

if (QWT_FOUND)

    include_directories(${QWT_INCLUDE_DIRS})
    list(APPEND Qt5_LIBRARIES ${QWT_LIBRARIES})
    message(STATUS "QWT_INCLUDE_DIRS: ${QWT_INCLUDE_DIRS}")
    message(STATUS "QWT_LIBRARIES: ${QWT_LIBRARIES}")

elseif (ENABLE_PLOTTERS)

    set(QWT_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/qwt6/src)

    if (NOT EXISTS ${QWT_SRC_DIR})
        message(FATAL_ERROR "Qwt submodule not configured (git submodule update --init --recursive)")
    endif ()

    set (QWT_VERSION_STRING 0)
    set ( _VERSION_FILE ${QWT_SRC_DIR}/qwt_global.h )
    if ( EXISTS ${_VERSION_FILE} )
      file ( STRINGS ${_VERSION_FILE} _VERSION_LINE REGEX "define[ ]+QWT_VERSION_STR" )
      if ( _VERSION_LINE )
        string ( REGEX REPLACE ".*define[ ]+QWT_VERSION_STR[ ]+\"(.*)\".*" "\\1" QWT_VERSION_STRING "${_VERSION_LINE}" )
      endif ()
    endif ()
    message(STATUS "QWT_VERSION_STRING: ${QWT_VERSION_STRING}")

    include_directories(${QWT_SRC_DIR})
    file(GLOB QWT_SOURCES "${QWT_SRC_DIR}/*.cpp")
    add_library(PothosQwt SHARED ${QWT_SOURCES})
    set_target_properties(PothosQwt PROPERTIES DEFINE_SYMBOL "QWT_MAKEDLL")
    set_target_properties(PothosQwt PROPERTIES VERSION ${QWT_VERSION_STRING})
    target_link_libraries(PothosQwt ${Qt5_LIBRARIES})
    install(TARGETS PothosQwt
        LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
        ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
        RUNTIME DESTINATION bin              # .dll file
    )
    list(APPEND Qt5_LIBRARIES PothosQwt)

endif (QWT_FOUND)

########################################################################
# plotter utils library
########################################################################
if (ENABLE_PLOTTERS)

include_directories(${Pothos_INCLUDE_DIRS}) #include Pothos/Config.hpp
file(GLOB PLOTTER_UTILS_SOURCES "PlotterUtils/*.cpp")
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/PlotterUtils)
add_library(PothosPlotterUtils SHARED ${PLOTTER_UTILS_SOURCES})
set_target_properties(PothosPlotterUtils PROPERTIES DEFINE_SYMBOL "POTHOS_PLOTTER_UTILS_MAKEDLL")
set_target_properties(PothosPlotterUtils PROPERTIES VERSION 0.2.0)
target_link_libraries(PothosPlotterUtils ${Qt5_LIBRARIES})
install(TARGETS PothosPlotterUtils
    LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
    ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
    RUNTIME DESTINATION bin              # .dll file
)
list(APPEND Qt5_LIBRARIES PothosPlotterUtils)

endif (ENABLE_PLOTTERS)

########################################################################
# Build plotter widgets
########################################################################
add_subdirectory(Constellation)
add_subdirectory(LogicAnalyzer)
add_subdirectory(Periodogram)
add_subdirectory(QwtWidgets)
add_subdirectory(Spectrogram)
add_subdirectory(WaveMonitor)

=== Constellation/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_CONSTELLATION "Enable Pothos Plotters.Constellation component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Constellation" ENABLE_PLOTTERS_CONSTELLATION "Constellation complex IQ data plotter")
if (NOT ENABLE_PLOTTERS_CONSTELLATION)
    return()
endif()

########################################################################
# Build constellation plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET Constellation
    SOURCES
        Constellation.cpp
        ConstellationWork.cpp
        ConstellationDisplay.cpp
    DOC_SOURCES Constellation.cpp
    LIBRARIES ${Qt5_LIBRARIES}
    DESTINATION plotters
)

=== LogicAnalyzer/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_LOGICANALYZER "Enable Pothos Plotters.LogicAnalyzer component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Logic Analyzer" ENABLE_PLOTTERS_LOGICANALYZER "Logic analyzer list-view debug display")
if (NOT ENABLE_PLOTTERS_LOGICANALYZER)
    return()
endif()

########################################################################
# Build logic analyzer plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET LogicAnalyzer
    SOURCES
        LogicAnalyzer.cpp
        LogicAnalyzerDisplay.cpp
    DOC_SOURCES LogicAnalyzer.cpp
    LIBRARIES ${Qt5_LIBRARIES}
    DESTINATION plotters
)

=== Periodogram/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_PERIODOGRAM "Enable Pothos Plotters.Periodogram component" ON "Spuce_FOUND;ENABLE_PLOTTERS" OFF)
add_feature_info("  Periodogram" ENABLE_PLOTTERS_PERIODOGRAM "Periodogram frequency-domain FFT plotter")
if (NOT ENABLE_PLOTTERS_PERIODOGRAM)
    return()
endif()

########################################################################
# Build frequency domain plot module
########################################################################
include_directories(${Spuce_INCLUDE_DIRS})

POTHOS_MODULE_UTIL(
    TARGET Periodogram
    SOURCES
        Periodogram.cpp
        PeriodogramWork.cpp
        PeriodogramChannel.cpp
        PeriodogramDisplay.cpp
    DOC_SOURCES Periodogram.cpp
    LIBRARIES
        ${Qt5_LIBRARIES}
        ${Spuce_LIBRARIES}
    DESTINATION plotters
)

=== QwtWidgets/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_QWTWIDGETS "Enable Pothos Plotters.QwtWidgets component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Qwt Widgets" ENABLE_PLOTTERS_QWTWIDGETS "Miscellaneous widgets based around Qwt")
if (NOT ENABLE_PLOTTERS_QWTWIDGETS)
    return()
endif()

########################################################################
# Build Qwt widgets module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET QwtWidgets
    SOURCES
        QwtSlider.cpp
        QwtThermo.cpp
        QwtKnob.cpp
        QwtDial.cpp
    ENABLE_DOCS
    LIBRARIES ${Qt5_LIBRARIES}
    DESTINATION plotters
)

=== Spectrogram/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_SPECTROGRAM "Enable Pothos Plotters.Spectrogram component" ON "ENABLE_PLOTTERS;Spuce_FOUND" OFF)
add_feature_info("  Spectrogram" ENABLE_PLOTTERS_SPECTROGRAM "Spectrogram frequency-domain FFT plotter")
if (NOT ENABLE_PLOTTERS_SPECTROGRAM)
    return()
endif()

########################################################################
# Build spectrogram plot module
########################################################################
include_directories(${Spuce_INCLUDE_DIRS})

POTHOS_MODULE_UTIL(
    TARGET Spectrogram
    SOURCES
        Spectrogram.cpp
        SpectrogramWork.cpp
        SpectrogramDisplay.cpp
        ColorMapEntry.cpp
        GeneratedColorMaps.cpp
        QwtColorMapMaker.cpp
    DOC_SOURCES Spectrogram.cpp
    LIBRARIES
        ${Qt5_LIBRARIES}
        ${Spuce_LIBRARIES}
    DESTINATION plotters
)

=== WaveMonitor/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_WAVEMONITOR "Enable Pothos Plotters.WaveMonitor component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Wave Monitor" ENABLE_PLOTTERS_WAVEMONITOR "Wavemonitor time-domain waveform plotter")
if (NOT ENABLE_PLOTTERS_WAVEMONITOR)
    return()
endif()

########################################################################
# Build time domain plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET WaveMonitor
    SOURCES
        WaveMonitor.cpp
        WaveMonitorWork.cpp
        WaveMonitorDisplay.cpp
    DOC_SOURCES WaveMonitor.cpp
    LIBRARIES ${Qt5_LIBRARIES}
    DESTINATION plotters
)

=== debian/changelog ===
pothos-plotters (0.4.1-1) unstable; urgency=low

  * Release 0.4.1 (2018-04-24)

 -- Josh Blum <josh@pothosware.com>  Tue, 24 Apr 2018 20:30:21 -0000

pothos-plotters (0.4.0-1) unstable; urgency=low

  * Release 0.4.0 (2017-12-25)

 -- Josh Blum <josh@pothosware.com>  Mon, 25 Dec 2017 11:32:08 -0000

pothos-plotters (0.3.1-1) unstable; urgency=low

  * Release 0.3.1 (2017-06-22)

 -- Josh Blum <josh@pothosware.com>  Thu, 22 Jun 2017 19:53:40 -0000

pothos-plotters (0.3.0-1) unstable; urgency=low

  * Release 0.3.0 (2017-04-27)

 -- Josh Blum <josh@pothosware.com>  Thu, 27 Apr 2017 17:00:27 -0000

pothos-plotters (0.2.2-1) unstable; urgency=low

  * Release 0.2.2 (2017-04-23)

 -- Josh Blum <josh@pothosware.com>  Sun, 23 Apr 2017 20:38:10 -0000

pothos-plotters (0.2.1-ppa1) unstable; urgency=low

  * Release 0.2.1 (2016-09-24)

 -- Josh Blum <josh@pothosware.com>  Sun, 25 Sep 2016 09:29:56 -0700

pothos-plotters (0.2.0) unstable; urgency=low

  * Release 0.2.0 (2016-08-02)

 -- Josh Blum <josh@pothosware.com>  Tue, 02 Aug 2016 14:27:00 -0700

pothos-plotters (0.1.1) unstable; urgency=low

  * Release 0.1.1 (2016-05-10)

 -- Josh Blum <josh@pothosware.com>  Tue, 10 May 2016 16:22:03 -0700

pothos-plotters (0.1.0) unstable; urgency=low

  * Release 0.1.0 (2015-12-16)

 -- Josh Blum <josh@pothosware.com>  Wed, 16 Dec 2015 16:30:45 -0800

=== debian/control ===
Source: pothos-plotters
Section: science
Priority: optional
Maintainer: Josh Blum <josh@pothosware.com>
Build-Depends:
    debhelper (>= 9.0.0),
    cmake (>= 2.8.9),
    libpoco-dev (>= 1.6),
    libpothos-dev,
    libspuce-dev,
    qtbase5-dev, libqt5svg5-dev, libqt5opengl5-dev,
    libqwt-qt5-dev
Standards-Version: 4.1.1
Homepage: https://github.com/pothosware/PothosPlotters/wiki
Vcs-Git: https://github.com/pothosware/PothosPlotters.git
Vcs-Browser: https://github.com/pothosware/PothosPlotters

Package: pothos-modules-plotters
Section: libs
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: pothos0.6-modules-plotters, ${misc:Depends}
Description: graphical plotter widgets - metapackage
 The Pothos data-flow software suite.

Package: pothos0.6-modules-plotters
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpothosplotterutils0.2.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: graphical plotter widgets
 The Pothos data-flow software suite.

Package: libpothosplotterutils0.2.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: plotter utility shared library
 The Pothos data-flow software suite.
